Subject: Re: [PATCH net-next 3/4] bridge: Consider the Nearest Customer Bridge group addresses

From: Stephen Hemminger <[email-masked]>
Date: Tue, 10 Jun 2014 09:21:27 -0700

On Tue, 10 Jun 2014 16:05:07 +0900
Toshiaki Makita <[email-masked]> wrote:

> (2014/06/10 7:33), Vlad Yasevich wrote:
> ...
> >>> Rather than special casing this around vlan filtering, I would prefer
> >>> the code always forward these packets, or manipulate group_fwd_mask
> >>> to allow it that way.
> >>
> >> These addresses must be forwarded only if the bridge is an S-VLAN
> >> bridge. When it is a C-VLAN bridge or a .1D bridge, they may not be
> >> forwarded. So, I don't think we can forward them always.
> >>
> >> Using group_fwd_mask is a bit complicated. If we use it to forward them,
> >> user can optionally turn off forwarding ability of those addresses...
> >> but we maybe need another information (named like group_fwd_mask_set)
> >> that indicates which bit is set by user. (We have to set group_fwd_mask
> >> automatically when we set vlan_proto to 88a8.)
> >> Is this way acceptable?
> > 
> > May be separate it into required mask and user mask.  Set required
> > mask when this is an S-VLAN bridge.
> 
> Sounds like a good idea.
> I'll give it a try, thank you for your suggestion.
> 
> Thanks,
> Toshiaki Makita
> 

Looking again at the code.

1. If doing vlan then it should forward frames as defined in standard
   by default.

2. For compatiability, and for those users doing bump-on-wire, allow
   forwarding via group mask.